diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
index f4f239602..6413e042e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
@@ -2,15 +2,15 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
 import org.useless.dragonfly.DisplayPos;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
@@ -49,15 +49,12 @@ public class MobRendererWolf extends MobRenderer<MobWolf> {
         final float limbYaw = getLimbYaw(entity, partialTick);
         final float limbPitch = getLimbPitch(entity, partialTick);
 
-        if(entity.isWolfAngry())
-        {
+        if (entity.isWolfAngry()) {
             tail.rotY = 0.0F;
-        } else
-        {
+        } else {
             tail.rotY = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
         }
-        if(entity.isWolfSitting())
-        {
+        if (entity.isWolfSitting()) {
             body.rotX = -33.5 * MathHelper.DEG_TO_RAD;
             body.posY = -4.5;
             body.posZ = -2;
@@ -81,8 +78,7 @@ public class MobRendererWolf extends MobRenderer<MobWolf> {
 
             tail.posY = -9;
             tail.posZ = -3;
-        } else
-        {
+        } else {
             leg0.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
             leg1.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
             leg2.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
@@ -93,10 +89,9 @@ public class MobRendererWolf extends MobRenderer<MobWolf> {
         body.rotZ = entity.getShakeAngle(partialTick, -0.16F);
         tail.rotZ = entity.getShakeAngle(partialTick, -0.2F);
 
-        if(entity.getWolfShaking())
-        {
+        if (entity.getWolfShaking()) {
             final float shading = brightness * entity.getShadingWhileShaking(partialTick);
-            GL11.glColor3f(shading, shading, shading);
+            GLRenderer.setColor3f(shading, shading, shading);
         }
 
         head.rotX = headPitch;
@@ -112,35 +107,30 @@ public class MobRendererWolf extends MobRenderer<MobWolf> {
     }
 
     @Override
-    protected float getLimbPitch(final @NotNull MobWolf wolf, final float partialTick)
-    {
-        if(wolf.isWolfAngry())
-        {
+    protected float getLimbPitch(final @NotNull MobWolf wolf, final float partialTick) {
+        if (wolf.isWolfAngry()) {
             return 88 * MathHelper.DEG_TO_RAD;
-        }
-        else if(wolf.isWolfTamed())
-        {
-            return (0.55F - (float)(wolf.getMaxHealth() - wolf.getHealth()) * 0.02F) * MathHelper.PI;
-        } else
-        {
+        } else if (wolf.isWolfTamed()) {
+            return (0.55F - (float) (wolf.getMaxHealth() - wolf.getHealth()) * 0.02F) * MathHelper.PI;
+        } else {
             return 36 * MathHelper.DEG_TO_RAD;
         }
     }
 
     @Override
-    protected void renderAdditional(@NotNull final Tessellator tessellator, final @NotNull MobWolf entity, final float partialTick){
+    protected void renderAdditional(@NotNull final TessellatorGeneral tessellator, final @NotNull MobWolf entity, final float partialTick) {
         final ItemStack itemstack = entity.getHeldItem();
 
-        if(itemstack != null) {
-            GL11.glPushMatrix();
+        if (itemstack != null) {
+            GLRenderer.pushFrame();
             getModel("main").translateToBone("mouthItem");
-            GL11.glScalef(MobRenderer.ENTITY_RENDER_SCALE, -MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
-            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-            GL11.glEnable(GL11.GL_BLEND);
-            ItemModelDispatcher.getInstance().getDispatch(itemstack).render(Tessellator.instance, entity, itemstack, DisplayPos.GROUND, Minecraft.getMinecraft().gameSettings.items3D.value, 1, entity.getBrightness(partialTick), 1f, partialTick, true);
-            GL11.glDisable(GL11.GL_BLEND);
-            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
-            GL11.glPopMatrix();
+            GLRenderer.modelM4f().scale(MobRenderer.ENTITY_RENDER_SCALE, -MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
+//            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+            GLRenderer.enableState(State.BLEND);
+            ItemModelDispatcher.getInstance().getDispatch(itemstack).render(GLRenderer.getTessellator(), entity, itemstack, DisplayPos.GROUND, Minecraft.getMinecraft().gameSettings.items3D.value, 1, entity.getLightmap(partialTick), partialTick, true);
+            GLRenderer.disableState(State.BLEND);
+//            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+            GLRenderer.popFrame();
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/Font.java b/game/client/src/main/java/net/minecraft/client/render/font/Font.java
index 1cdd19a31..316a08e2a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/Font.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/Font.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
@@ -24,5 +24,5 @@ public interface Font {
 
     int fontHeight();
 
-    double renderChar(Tessellator tessellator, char c, double x, double y, double z, boolean italics);
+    double renderChar(TessellatorFont tessellator, char c, double x, double y, double z, boolean italics);
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
index fe7abeb4b..50e03f9e1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.font;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import org.jetbrains.annotations.NotNull;
@@ -47,7 +47,7 @@ public class FontDefault extends FontFile {
     }
 
     @Override
-    public double renderChar(final Tessellator tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
+    public double renderChar(final TessellatorFont tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
         if (c == ' ') return 4;
         final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
         if (fontIndex < 0) return 0;
@@ -56,28 +56,20 @@ public class FontDefault extends FontFile {
 
         final int upper = this.charWidth[fontIndex] >> 4;
         final int lower = this.charWidth[fontIndex] & 0x0F;
-        final double fUpper = upper;
-        final double fLower = (lower + 1);
+        final int fUpper = upper;
+        final int fLower = (lower + 1);
         if (fLower - fUpper == 0) return 0;
 
-        final double epsilon = 0.02/256;
-        final double u = (fontIndex % 16 * 16) + fUpper;
-        final double v = (fontIndex & 255) / 16 * 16;
-        final double uWidth = fLower - fUpper;
-        final double vHeight = 16d;
-
-        final double uMin = u / 256d;
-        final double uMax = (u + uWidth) / 256d;
-        final double vMin = v / 256d;
-        final double vMax = (v + vHeight) / 256d;
+        final int u = (fontIndex % 16 * 16) + fUpper;
+        final int v = (fontIndex & 0xff) / 16 * 16;
+        final int uWidth = fLower - fUpper;
+        final int vHeight = 16;
 
         final double width = uWidth/2d;
         final double height = vHeight/2d;
 
-        tessellator.addVertexWithUV(x + shift,          y,           z, uMin + epsilon, vMin + epsilon);
-        tessellator.addVertexWithUV(x - shift,          y + height,  z, uMin + epsilon, vMax - epsilon);
-        tessellator.addVertexWithUV(x - shift + width,  y + height,  z, uMax - epsilon, vMax - epsilon);
-        tessellator.addVertexWithUV(x + shift + width,  y,           z, uMax - epsilon, vMin + epsilon);
+        tessellator.addChar(x, y, width, height, shift, u/256d, v/256d, uWidth/256d, vHeight/256d);
+
         return (fLower - fUpper)/2d + 1;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java b/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
index be72ac583..58dc898fc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
@@ -1,7 +1,8 @@
 package net.minecraft.client.render.font;
 
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
@@ -18,9 +19,10 @@ public class FontFile implements Font {
      * Some characters somehow are recognized as "default" characters while their rendering is not supported.
      * Have to delete this once workarounds are found.
      */
-    protected static final List<Character> DEFAULT_BLACKLIST = Arrays.asList(
-        '\uff0c', '\u3002', '\u3001', '\u3010', '\u3011', '\uff1b', '\u2019', '\u2018', '\u201c', '\u201d', '\uff1f', '\uff01', '\u00b7'
-    );
+    protected static final List<Character> DEFAULT_BLACKLIST = new ObjectArrayList<>();
+    static {
+        DEFAULT_BLACKLIST.addAll(Arrays.asList('\uff0c', '\u3002', '\u3001', '\u3010', '\u3011', '\uff1b', '\u2019', '\u2018', '\u201c', '\u201d', '\uff1f', '\uff01', '\u00b7'));
+    }
 
     protected static final int ITALICS_SHIFT = 1;
     protected static final int GLYPHS_PER_TEXTURE = 256;
@@ -108,34 +110,26 @@ public class FontFile implements Font {
     }
 
     @Override
-    public double renderChar(final Tessellator tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
+    public double renderChar(final TessellatorFont tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
         if (c == ' ') return 4;
         final int shift = italics ? ITALICS_SHIFT : 0;
 
         final int upper = this.charWidth[c] >> 4;
         final int lower = this.charWidth[c] & 0x0F;
-        final double fUpper = upper;
-        final double fLower = (lower + 1);
+        final int fUpper = upper;
+        final int fLower = (lower + 1);
         if (fLower - fUpper == 0) return 0;
 
-        final double epsilon = 0.02/256;
-        final double u = (c % 16 * 16) + fUpper;
-        final double v = (c & 255) / 16 * 16;
-        final double uWidth = fLower - fUpper;
-        final double vHeight = 16d;
-
-        final double uMin = u / 256d;
-        final double uMax = (u + uWidth) / 256d;
-        final double vMin = v / 256d;
-        final double vMax = (v + vHeight) / 256d;
+        final int u = (c % 16 * 16) + fUpper;
+        final int v = (c & 255) / 16 * 16;
+        final int uWidth = fLower - fUpper;
+        final int vHeight = 16;
 
         final double width = uWidth/2d;
         final double height = vHeight/2d;
 
-        tessellator.addVertexWithUV(x + shift,          y,           z, uMin + epsilon, vMin + epsilon);
-        tessellator.addVertexWithUV(x - shift,          y + height,  z, uMin + epsilon, vMax - epsilon);
-        tessellator.addVertexWithUV(x - shift + width,  y + height,  z, uMax - epsilon, vMax - epsilon);
-        tessellator.addVertexWithUV(x + shift + width,  y,           z, uMax - epsilon, vMin + epsilon);
+        tessellator.addChar(x, y, width, height, shift, u/256d, v/256d, uWidth/256d, vHeight/256d);
+
         return (fLower - fUpper)/2d + 1;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java b/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
index fbb29546b..254252278 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import org.jetbrains.annotations.NotNull;
@@ -31,34 +31,25 @@ public class FontMonospace extends FontFile{
     }
 
     @Override
-    public double renderChar(final Tessellator tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
+    public double renderChar(final TessellatorFont tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
         if (c != ' ') {
             final int shift = italics ? ITALICS_SHIFT : 0;
             final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
             if (fontIndex < 0) return 0;
 
-            final double epsilon = 0.02/256;
             final int upper = this.charWidth[fontIndex] >> 4;
             final int lower = this.charWidth[fontIndex] & 0x0F;
-            final double fUpper = upper;
-            final double fLower = (lower + 1);
-            final double u = (fontIndex % 16 * 16) + fUpper;
-            final double v = (fontIndex & 255) / 16 * 16;
-            final double uWidth = fLower - fUpper;
-            final double vHeight = 16d;
-
-            final double uMin = u / 256d;
-            final double uMax = (u + uWidth) / 256d;
-            final double vMin = v / 256d;
-            final double vMax = (v + vHeight) / 256d;
+            final int fUpper = upper;
+            final int fLower = (lower + 1);
+            final int u = (fontIndex % 16 * 16) + fUpper;
+            final int v = (fontIndex & 255) / 16 * 16;
+            final int uWidth = fLower - fUpper;
+            final int vHeight = 16;
 
             final double width = uWidth/2d;
             final double height = vHeight/2d;
 
-            tessellator.addVertexWithUV(x + shift,          y,           z, uMin + epsilon, vMin + epsilon);
-            tessellator.addVertexWithUV(x - shift,          y + height,  z, uMin + epsilon, vMax - epsilon);
-            tessellator.addVertexWithUV(x - shift + width,  y + height,  z, uMax - epsilon, vMax - epsilon);
-            tessellator.addVertexWithUV(x + shift + width,  y,           z, uMax - epsilon, vMin + epsilon);
+            tessellator.addChar(x, y, width, height, shift, u/256d, v/256d, uWidth/256d, vHeight/256d);
         }
         return MONOSPACE_WIDTH / 2d + 1;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
index 9bdc88504..08c4e334a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
